(function($) {
    'use strict';

    /**
     * 转化url参数为object对象
     * @date: 2015-12
     */

    var isIphone = /iphone/i.test(navigator.userAgent.toLowerCase());
    var isAndroid = /android/i.test(navigator.userAgent.toLowerCase());
    var isWeixin = /micromessenger/i.test(navigator.userAgent.toLowerCase());
    var isMobile =
        /iphone|android|ucweb|ucbrowser|nokia|sony|ericsson|mot|samsung|sgh|lg|philips|panasonic|alcatel|lenovo|cldc|midp|wap|mobile/i
        .test(navigator.userAgent.toLowerCase()) && !/ipad/i.test(navigator.userAgent.toLowerCase());

    var parseUrlParams = function() {
        var serach = document.location.search.substr(1),
            p = serach.split('&'),
            obj = {};
        for (var i = 0; i < p.length; i++) {
            var _t = p[i].split('=');
            if (_t[1]) {
                obj[_t[0]] = _t[1];
            }
        }
        return obj;
    };

    /**
     * 编译音频模板
     * @date: 2016-04
     */
    var compileAudioTemplate = function() {
        // 获取 <audio> 属性
        var getAttr = function(content, attr) {
            var reg = new RegExp('"'+attr + '"="([^"]*)"', 'ig');
            var result = reg.exec(content);
            if(result && result.length  > 0) {
                return result[1].replace(/"/g,'');
            }
            return '';
        }

        // 编译模板
        $('audio').each(function(index, audio) {
            var strAudio = $(audio).get(0).outerHTML,
                albumUrl = getAttr(strAudio, 'albumurl');
            var wrapper = '<div class="audio-wrapper">'
                + '<div class="album">'
                    + '<a class="control stop"></a>'
                    + (albumUrl ? '<img src="' + albumUrl + '" alt="" id="album_pic"/>' : '')
                + '</div>'
                + '<div class="singer">'
                    + '<h5>' + getAttr(strAudio, 'music_name')+'</h5>'
                    + '<h6 style="line-height:16px;">'+ getAttr(strAudio, 'singer') +'</h6>'
                    + strAudio
                + '</div>'
            +'</div>';
            $(audio).get(0).outerHTML = wrapper;
        })
    };


    $(document).ready(function() {
        var $header = $('.header'),
            $download = $('.download-wrapper'),
            urlParams = parseUrlParams();

        // 只在android浏览器下显示下载栏
//        if (isAndroid) {
//            $download.show();
//        }

        // 隐藏下载栏
        $('.link-close').click(function() {
            $download.hide();
        });

        mWebViewImageListener.documentReady();

        // 显示站点信息
        if(urlParams && urlParams['site_id']) {
            var siteIconUrl = 'http://image.smartisanos.cn/rss/site_pic/'+ urlParams['site_id'] + '.png';
            $header.find('.logo').attr('src', siteIconUrl);
            $header.show();
        }

        // 日期下移
        if(urlParams && urlParams['date_version'] && $('.header .date').text() && $('.content').has('.date').length === 0) {
            if($('.author').length === 0) {
                $('h1').after('<h6 class="author"></h6>')
            }
            // 有作者时
            if($('.author').text()) {
                $('.content .author').html('<span class="author-name">' +$('.author').text()+ '</span>' + '<span class="date">'+ $('.header .date').text() + '</span>');
            } else {
                $('.content .author').html('<span class="date">'+ $('.header .date').text() + '</span>');
            }
            $('.header .date').text('')
        }
        // 更新字体大小
        if (urlParams && urlParams['ft_size']) {
            $('body').removeClass().addClass('screen-' + urlParams['ft_size']);
        }

        // 编译音频模板
        var $audio = $('body audio');
        var $audio_wrapper = $('body .audio-wrapper');
        // 判断<audio> 和 <div class="audio-wrapper">数量，避免重复编译
        if($audio.length != $audio_wrapper.length && $audio.length > 0){
            compileAudioTemplate();
        }

        // 播放器
        $(document).on('click','.audio-wrapper', function(evt) {
            var $wrapper = $(evt.currentTarget),
                $control = $wrapper.find('.control'),
                $audio = $wrapper.find('audio');
            if($control.is('.stop')) {
                $control.removeClass('stop').addClass('start');
                $audio.get(0).play();
            } else {
                $control.removeClass('start').addClass('stop');
                $audio.get(0).pause();
            }
        });

        // 播放完毕后，更换播放图标
        if($audio.children().length != 0){
            var $control = $(document).find('.audio-wrapper').find('.control');
            $audio.get(0).addEventListener('ended', function(){
                if($control.is('.start'))
                    $control.removeClass('start').addClass('stop');
            }, false);
            $audio.get(0).addEventListener('pause', function(){
                $control.removeClass('start').addClass('stop');
            }, false);
        }

//        // 大图片处理
//        var isWifiConnected = mWebViewImageListener.isWifiConnected();
//        var $picture = $('body .content img');
//        var shouldRewriteHtml = false;
////        if(!isWifiConnected){
//            for(var i = 0; i < $picture.length; i++){
//                var src = $picture.eq(i).attr('src');
//                // 通过判断图片scr 是否与指定图片相符，以及是否已经含有 index 属性（是否已经处理过），
//                // 来查看是否需要替换图片。
//                if(src.substr(0,4) != "http://image.s-reader.com/rss/image/1577c4ec-e663-3526-8641-1835704d6812.png"
//                    && !$picture.eq(i).attr('index')){
//                    var $src_origin = $picture.eq(i).clone();
//                    if(typeof $src_origin !== typeof undefined && $src_origin !== false){
//                        $picture.eq(i).attr('src_origin', $src_origin.attr('src'));
//                        $picture.eq(i).attr('src','http://image.s-reader.com/rss/image/1577c4ec-e663-3526-8641-1835704d6812.png');
//                    }
//                }
//            }
////        }

        var $dom_a = $('body a');
        for(var i = 0; i < $dom_a.length; i++){
            var $dom_a_img = $dom_a.eq(i).find('img');
            if($dom_a_img.length > 0){
                var a_href = $dom_a.eq(i).attr('href');
                // 把指向图片的链接,以及不以 http 开头的链接删除
                if(a_href.substr(a_href.length - 3, 3) == "jpg"
                    || a_href.substr(a_href.length - 3, 3) == "png"
                    || a_href.substr(a_href.length - 4, 4) == "jpeg"
                    || a_href.substr(0, 4) != "http"){
                        $dom_a.eq(i).attr('href',null);
                    }
            }
        }

        // 检查<script>标签，如果存在src，并且域名不是smartisan的，
        // 判定被恶意注入js，把该标签删除。
        var hasRemoved = false;
        var $head_script = $('head script');
        for(var i = 0; i < $head_script.length; i++){
            var src = $head_script.eq(i).attr("src");
            if(typeof src !== typeof undefined && src !== false){
                var index_slash = src.indexOf("/");
                if(typeof index_slash != typeof undefined && index_slash > 0){
                    if(src.substr(index_slash + 2, index_slash + 16) != "static.smartisanos.cn"
                        && src.substr(0, 21) != "other_style/smartisan"){
                        $head_script.eq(i).remove();
                        hasRemoved = true;
                    }
                }
            }
        }

        var $body_script = $('body script');
        for(var i = 0; i < $body_script.length; i++){
            var src = $body_script.eq(i).attr("src");
            if(typeof src !== typeof undefined && src !== false){
                var index_slash = src.indexOf("/");
                if(typeof index_slash != typeof undefined && index_slash > 0){
                    if(src.substr(index_slash + 2, index_slash + 16) != "static.smartisanos.cn"
                        && src.substr(0, 21) != "other_style/smartisan"){
                        $body_script.eq(i).remove();
                        hasRemoved = true;
                    }
                }
            }
        }

        // 结束时把过滤后的html文件传给java端
        var after_html = document.getElementsByTagName('html')[0].outerHTML;

        //Notify app that page load finish.
        mWebViewImageListener.onPageLoadFinish(after_html, hasRemoved);
    });
})(Zepto);

function onLoaded() {
    var allImage = document.querySelectorAll(".rss-wrapper .content img");
    allImage = Array.prototype.slice.call(allImage, 0);
    var index = 0;
    allImage.forEach(function(image) {
        if(image.id != "album_pic"){
            //reset img status to normal.
//            if(image.hasAttribute("esrc")){
//                console.log("reset image status");
//                var esrc = image.getAttribute("esrc");
//                image.removeAttribute("esrc");
//                image.removeAttribute("onClick");
//                image.src = esrc;
//            }
//            var imageUrl = image.src;
//            image.setAttribute("esrc", imageUrl);
//            image.removeAttribute("src");
            var onClickUrl = "javascript:onImageClick('" +index +"')";
            image.setAttribute("onclick", onClickUrl);
            image.setAttribute("index", index);
//            mWebViewImageListener.loadImage(imageUrl, index);
            index = index + 1;
        }
    });
}

function onImageLoadingComplete(pOldUrl, pNewUrl) {
    var allImage = document.querySelectorAll(".rss-wrapper .content img");
    allImage = Array.prototype.slice.call(allImage, 0);
    allImage.forEach(function(image) {
        if (image.getAttribute("esrc") == pOldUrl || image.getAttribute("esrc") == decodeURIComponent(pOldUrl)) {
            if(image.hasAttribute("src")){
                image.src = pNewUrl;
            } else {
                image.setAttribute("src", pNewUrl);
            }
        }
    });
}

function changeSrc(url,index){
    var allImage = document.querySelectorAll(".rss-wrapper .content img");
    allImage = Array.prototype.slice.call(allImage, 0);

    allImage.forEach(function(image) {
        if(image.hasAttribute("index") && image.getAttribute("index") == index ){
            if(!image.hasAttribute("src")){
                image.setAttribute("src", url);
            } else{
                image.src = url;
            }

            if(image.hasAttribute("src_origin")){
                image.removeAttribute("src_origin");
            }
            if(image.hasAttribute("esrc")){
                image.removeAttribute("esrc");
            }
        }
    });
}

function rewriteHtml(){
    var html = document.getElementsByTagName('html')[0].outerHTML;
    mWebViewImageListener.rewriteHtml(html);
}

function onImageClick(index){
    var allImage = document.querySelectorAll(".rss-wrapper .content img");
    allImage = Array.prototype.slice.call(allImage, 0);
    var urls = new Array();
    allImage.forEach(function(image) {
        var imgUrl = image.getAttribute("src");
        //先把qq音乐的音频背景过滤掉，目前没有发现其它网站的音频，以后发现再添加
        if(imgUrl.indexOf("https://imgcache.qq.com/music/") == -1){
          urls.push(imgUrl);
        }
    });
   mWebViewImageListener.onImageClick(urls,parseInt(index));
}

function changeTextSize(fontSize){
    // 更新字体大小
    $('body').removeClass().addClass('screen-' + fontSize);
}

//function onImageClick(index){
//    var allImage = document.querySelectorAll(".rss-wrapper .content img");
//    allImage = Array.prototype.slice.call(allImage, 0);
//    var urls = new Array();
//    var i = 0;
//    var showAllPic = true;
//    var indexShowPic = 0;
//
//    allImage.forEach(function(image) {
//        if(i == index){
//            var imageUrl = image.getAttribute("src");
//            // 如果src是本地图片，调用java端loadImage()方法，下载网络图片并替换src
//            if(imageUrl != null &&
//                imageUrl == "http://image.s-reader.com/rss/image/1577c4ec-e663-3526-8641-1835704d6812.png"){
//                var imageUrl = image.getAttribute("src_origin");
//                if(imageUrl !== null){
//                    showAllPic = false;
//                    mWebViewImageListener.loadImage(imageUrl, parseInt(index));
//                    mWebViewImageListener.setShouldRewriteHtml(true);
//                }
//            }
//        }
//
//        var imgUrl = image.getAttribute("src");
//        // 判断每一张图片的src，如果不指向本地图片，把src地址 push 进urls数组中
//        if(imgUrl != "http://image.s-reader.com/rss/image/1577c4ec-e663-3526-8641-1835704d6812.png"){
//            urls.push(imgUrl);
//            // 计算当前点击的图片，在所有可全屏显示图片位置
//            if(i <= index){
//                indexShowPic++;
//            }
//        }
//
//        i++;
//    });
//
//    if(showAllPic){
//        mWebViewImageListener.onImageClick(urls, indexShowPic - 1);
//    }
//}
