package com.netease.nim.uikit.business.contact.core.util

import android.view.View
import com.netease.nim.uikit.business.reply.bubble.FlashBubbleItemView
import com.netease.nim.uikit.common.util.sys.ScreenUtil
import com.bullet.libcommonutil.util.UIHandler

class BubbleMoveScrollListener : FlashBubbleItemView.OnScrollChangeListener {

    private var beforeY: Int = 0
    private var scrollHeight: Int = 0

    var view: View? = null

    override fun onSoftKeyBoardChange(scrollHeight: Int, visible: Boolean) {
        UIHandler.postDelayed({ scrollRecycleView(scrollHeight, visible) }, 300)
    }

    override fun onBeforeScroll() {
        view?.let {
            beforeY = ScreenUtil.getLocationOnScreen(it)[1]
        }
    }

    private fun scrollRecycleView(upHeight: Int, visible: Boolean) {
        view?.let {
            scrollHeight = if (visible) upHeight else ScreenUtil.getLocationOnScreen(view)[1] - beforeY
            if (scrollHeight == 0) return
            FlashBubbleMoveSubscriber.observeMove(scrollHeight)
        }
    }

}