package com.netease.nim.uikit.business.contact.core.util

import org.greenrobot.eventbus.EventBus
import org.greenrobot.eventbus.Subscribe
import org.greenrobot.eventbus.ThreadMode

class FlashBubbleMoveSubscriber {

    companion object {
        fun observeMove(y: Int) {
            EventBus.getDefault().post(OnMoveEvent(y))
        }
    }

    private var moveObserver: FlashBubbleMoveObserver? = null

    fun subscribe(observer: FlashBubbleMoveObserver) {
        moveObserver = observer
        EventBus.getDefault().register(this)
    }

    fun unSubscribe() {
        moveObserver = null
        EventBus.getDefault().unregister(this)
    }

    @Subscribe(threadMode = ThreadMode.MAIN)
    fun onEvent(event: OnMoveEvent) {
        moveObserver?.onMove(event.y)
    }


    interface FlashBubbleMoveObserver {
        fun onMove(y: Int)
    }

    data class OnMoveEvent(val y: Int)

}

