package com.netease.nim.uikit.business.contact.core.util

import org.greenrobot.eventbus.EventBus
import org.greenrobot.eventbus.Subscribe
import org.greenrobot.eventbus.ThreadMode

class ReplyTypeChangeSubscriber {

    companion object {
        fun observeChange(isVoiceReply: Boolean) {
            EventBus.getDefault().post(OnChangeEvent(isVoiceReply))
        }
    }

    private var moveObserver: ReplyTypeChangeObserver? = null

    fun subscribe(observer: ReplyTypeChangeObserver) {
        moveObserver = observer
        EventBus.getDefault().register(this)
    }

    fun unSubscribe() {
        moveObserver = null
        EventBus.getDefault().unregister(this)
    }

    @Subscribe(threadMode = ThreadMode.MAIN)
    fun onEvent(event: OnChangeEvent) {
        moveObserver?.onChange(event.isVoiceReply)
    }


    interface ReplyTypeChangeObserver {
        fun onChange(isVoiceReply: Boolean)
    }

    data class OnChangeEvent(val isVoiceReply: Boolean)

}

