package com.netease.nim.uikit.business.forward.adapter

import com.bullet.messenger.widgetkit.adapter.BaseRecyclerAdapter
import com.bullet.messenger.widgetkit.viewholder.BaseRecyclerViewHolder
import com.bullet.messenger.widgetkit.viewholder.ViewHolderFactory
import com.netease.nim.uikit.business.forward.data.*
import com.netease.nim.uikit.business.forward.viewholder.CardMessageViewHolder
import com.netease.nim.uikit.business.forward.viewholder.ImageMessageViewHolder
import com.netease.nim.uikit.business.forward.viewholder.TextMessageViewHolder
import com.netease.nim.uikit.business.forward.viewholder.VideoMessageViewHolder

class ForwardMsgAdapter : BaseRecyclerAdapter() {
    companion object {
        private val TAG: String = ForwardMsgAdapter::class.java.name
    }

    override fun getViewHolderFactoryByModel(model: Any): ViewHolderFactory<BaseRecyclerViewHolder<*>> {

        return when (model) {
            is NIMTextObject -> TextMessageViewHolder.Companion
            is NIMImageObject -> ImageMessageViewHolder.Companion
            is NIMVideoObject -> VideoMessageViewHolder.Companion
            is NIMFileObject -> CardMessageViewHolder.Companion
            is NIMLocationObject -> CardMessageViewHolder.Companion
            is SMCardAttachment -> CardMessageViewHolder.Companion
            else -> throw ClassNotFoundException("$TAG know data type!!!!")
        }
    }
}
