package com.netease.nim.uikit.business.forward.viewholder

import android.view.View
import com.bullet.messenger.widgetkit.viewholder.BaseRecyclerViewHolder
import com.netease.nim.uikit.business.forward.data.ForwardMsgModel
import com.netease.nim.uikit.common.ui.widget.imageloader.AvatarImageLoader
import kotlinx.android.synthetic.main.layout_msg_image.view.*

abstract class BaseMessageViewHolder<T : ForwardMsgModel>(itemView: View) : BaseRecyclerViewHolder<T>(itemView) {

    private fun loadUserInfo(date: T?) {
        itemView.userNameView.text = date?.userName
        AvatarImageLoader.getInstance().loadP2PAvatar(itemView.userAvatar, date?.userId)
    }

    override fun configModel(model: Any) {
        super.configModel(model)
        loadUserInfo(this.model)
    }

}