package com.netease.nim.uikit.business.passphrase

import android.app.Activity
import android.text.TextUtils
import android.widget.Toast
import com.bullet.chat.grpc.*
import com.netease.nim.uikit.api.NimUIKit
import com.netease.nim.uikit.business.contact.AddFriendPresenter
import com.netease.nim.uikit.business.contact.source.FriendSourceType
import com.smartisan.libstyle.toast.NimToast
import com.netease.nimlib.sdk.NIMClient
import smartisan.cloud.im.GrpcCallback
import smartisan.cloud.im.GrpcClient
import smartisan.cloud.im.grpc.ProtoBuffManager
import com.netease.nimlib.sdk.friend.FriendService


object PassphraseUtil {

    fun genaratePassphrase(type: WatchWordType, callback: GrpcCallback<GenerateWatchWordResponse>) {
        GrpcClient.getInstance().execute(object : GrpcClient.GrpcClientCallback<GenerateWatchWordResponse> {
            override fun onExcute(): GenerateWatchWordResponse {

                val stub = ProtoBuffManager.getInstance().doGetAccountStub()
                return stub.generateWatchWord(GenerateWatchWordRequest.newBuilder().setType(type).build())
            }

            override fun getUserCallback(): GrpcCallback<GenerateWatchWordResponse> {
                return callback
            }
        })
    }


    private fun resolvePassphrase(passphraseChar: String, callback: GrpcCallback<ParseWatchWordResponse>) {
        if (TextUtils.isEmpty(passphraseChar)) return

        GrpcClient.getInstance().execute(object : GrpcClient.GrpcClientCallback<ParseWatchWordResponse> {
            override fun onExcute(): ParseWatchWordResponse {

                val stub = ProtoBuffManager.getInstance().doGetAccountStub()
                return stub.parseWatchWord(ParseWatchWordRequest.newBuilder().setWatchWord(passphraseChar.toString()).build())
            }

            override fun getUserCallback(): GrpcCallback<ParseWatchWordResponse> {
                return callback
            }
        })
    }


    fun resolvePassHandle(string: String, activity: Activity, callback: () -> Unit) {
        if (activity == null) return
        PassphraseUtil.resolvePassphrase(string, object : GrpcCallback<ParseWatchWordResponse>() {
            override fun onSuccess(ParseWatchWordResponse: ParseWatchWordResponse) {
                if (activity == null || ParseWatchWordResponse == null || TextUtils.isEmpty(ParseWatchWordResponse.accid)) return

//                UserPreferences.saveString("clip_watch_word",string)
                callback() // 清除粘贴板
                if (NimUIKit.getAccount().equals(ParseWatchWordResponse.accid)) {
                    return
                }
                if (NIMClient.getService(FriendService::class.java).isMyFriend(ParseWatchWordResponse.accid)) {
//                    NimUIKit.startP2PSession(activity, ParseWatchWordResponse.accid);

                    NimToast.makeToast(activity, String.format(activity.getString(com.netease.nim.uikit.R.string.already_friend_tips), ParseWatchWordResponse.name), Toast.LENGTH_SHORT).show()
                    return
                }
                var presenter = AddFriendPresenter(activity)
                presenter.onAddFriendByVerify(ParseWatchWordResponse.accid, ParseWatchWordResponse.name, ParseWatchWordResponse.avatar, ParseWatchWordResponse.lmId, FriendSourceType(FriendSourceType.TYPE_PASSPHRASE, null), com.netease.nim.uikit.R.string.add_friend,
                        com.netease.nim.uikit.R.string.add_friend,
                        com.netease.nim.uikit.R.string.cancel, AddFriendPresenter.AddFriendEnum.Passphrase)
            }
        })
    }

}