package com.netease.nim.uikit.business.redpacket

import com.bullet.redpacket.c2c.v2.grpc.GetReceivedListResponse
import java.math.BigDecimal

class ReceivedData(val originData: GetReceivedListResponse.ReceivedList,
                   var isWinner: Boolean,
                   var isLoser: Boolean) {
    fun getFormatAmount(): String {
        return String.format("%.2f", getAmount())
    }
}

fun ReceivedData?.getAmount(): BigDecimal {
    return this?.originData?.amount?.toBigDecimalOrNull() ?: BigDecimal("0")
}

fun ReceivedData?.getCreateTime(): Long {
    return this?.originData?.createTime ?: 0L
}