package com.netease.nim.uikit.business.redpacket

import android.app.Activity
import android.graphics.Rect
import android.support.v4.app.FragmentActivity
import com.bullet.libcommonutil.util.UIHandler
import com.bullet.redpacket.c2c.v2.grpc.RedPacketStatus
import com.netease.nim.uikit.R
import com.netease.nim.uikit.api.NimUIKit
import com.netease.nim.uikit.business.redpacket.activity.RedPacketInfoB2CActivity
import com.netease.nim.uikit.business.redpacket.fragment.BaseRedPacketInfoFragment
import com.netease.nim.uikit.business.redpacket.fragment.RedPacketInfoB2CFragment

class RedDialogTest {

    private var redPacketDialog: RedPacketDialog? = null

    fun showDialog(activity: FragmentActivity) {
        val builder = RedPacketDialog.Builder(activity).apply {
            fromAccount = NimUIKit.getAccount()
            message = "dddd"
            open = {
                openSuccessAnimation("0.01", activity)
            }
            redPacketStatus = RedPacketStatus.CREATE
        }
        redPacketDialog = builder.build()
        redPacketDialog?.show()
    }

    private fun openSuccessAnimation(amount: String?, activity: FragmentActivity) {
        val realAmount = amount ?: activity.getString(R.string.default_money)
        val frag = RedPacketInfoB2CFragment.newInstance(realAmount, true, false)
        frag.rpInfoFragLifeCallback = object : BaseRedPacketInfoFragment.RpInfoFragLifeCallback() {
            override fun onViewCreated(frag: BaseRedPacketInfoFragment) {
                frag.startAnimation()
            }

            override fun onAnimationStart(frag: BaseRedPacketInfoFragment, avatarRect: Rect) {
                redPacketDialog?.opening(avatarRect)
            }

            override fun onAnimationEnd(frag: BaseRedPacketInfoFragment) {

                redPacketDialog?.dismiss()
                RedPacketInfoB2CActivity.starter(activity, realAmount, false)
                activity.overridePendingTransition(R.anim.fake_anim, R.anim.fake_anim)
                UIHandler.postDelayed({
                    activity.supportFragmentManager?.beginTransaction()
                            ?.remove(frag)
                            ?.commitAllowingStateLoss()
                }, RemoveFakeViewDelay)
            }
        }

        activity.supportFragmentManager.beginTransaction()
                .add(android.R.id.content, frag)
                .commitAllowingStateLoss()
    }
}