package com.netease.nim.uikit.business.redpacket.activity

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.view.View
import com.netease.nim.uikit.R
import com.netease.nim.uikit.business.redpacket.adapter.InvitedListAdapter
import com.netease.nim.uikit.common.activity.UI
import com.netease.nim.uikit.common.activity.titlebar.DefaultLeftOptions
import com.netease.nim.uikit.common.activity.titlebar.DefaultTitleOptions
import com.netease.nim.uikit.common.activity.titlebar.TitleBarOptions
import com.smartisan.pullToRefresh.PullToRefreshListView
import java.util.*

/**
 * Created by lan on 2018/9/6.
 */
class InvitedListActivity : UI() {

    private val mData : ArrayList<Map<String, String>> by lazy {
        ArrayList<Map<String, String>>()
    }

    private val mInvitedListAdapter : InvitedListAdapter by lazy {
        InvitedListAdapter(this, mData)
    }

    companion object {
        fun start(context: Context) {
            context.startActivity(Intent(context, InvitedListActivity::class.java))
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_invited_list)

        initTitleBar()
        initView()
        initData()
    }

    private fun initTitleBar() {
        val builder = TitleBarOptions.Builder()
                .leftAction(object : DefaultLeftOptions(this) {
                    override fun onClick(view: View?) {
                        onBackPressed()
                    }
                })
                .titleAction(DefaultTitleOptions(this, R.string.invited_list))
        setTitleBar(R.id.toolbar, builder.build())
    }

    private fun initView() {
        val mItemList = findViewById(R.id.invited_list) as PullToRefreshListView
        mItemList.setEnabledPullDownToRefresh(false)
        mItemList.setAdapter(mInvitedListAdapter)
    }

    private fun initData() {
        val data = ArrayList<Map<String, String>>()
        val item1 = HashMap<String, String>()
        item1.put("name", "小红")
        item1.put("source", "0")
        item1.put("state", "1")
        data.add(item1)
        val item2 = HashMap<String, String>()
        item2.put("name", "小绿")
        item2.put("source", "1")
        item2.put("state", "2")
        data.add(item2)
        val item3 = HashMap<String, String>()
        item3.put("name", "小紫")
        item3.put("source", "0")
        item3.put("state", "0")
        data.add(item3)
        val item4 = HashMap<String, String>()
        item4.put("name", "小黄")
        item4.put("source", "1")
        item4.put("state", "0")
        data.add(item3)

        mData.clear()
        mData.addAll(data)
    }
}