package com.netease.nim.uikit.business.redpacket.activity

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.view.View
import com.netease.nim.uikit.R
import com.netease.nim.uikit.business.redpacket.InviteUrl
import com.netease.nim.uikit.business.redpacket.presenter.WalletPresenter
import com.netease.nim.uikit.business.websearch.BrowserDispatcher
import com.netease.nim.uikit.common.activity.UI
import com.netease.nim.uikit.common.activity.titlebar.DefaultLeftOptions
import com.netease.nim.uikit.common.activity.titlebar.DefaultTitleOptions
import com.netease.nim.uikit.common.activity.titlebar.TitleBarOptions
import kotlinx.android.synthetic.main.activity_b2c_wallet.*
import kotlinx.android.synthetic.main.b2c_info_header_layout.view.*

/**
 * Created by lan on 2018/9/5.
 */
class PersonalWalletActivity : UI(), WalletPresenter.WalletView {

    companion object {
        fun start(context: Context) {
            context.startActivity(Intent(context, PersonalWalletActivity::class.java))
        }
    }

    private val walletPresenter by lazy {
        WalletPresenter(this)
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_b2c_wallet)
        initTitleBar()
        walletPresenter.onAttach(this)

        getCashButton.setOnClickListener {
            GetCashActivity.start(this)
        }

        inviteMoreButton.setOnClickListener {
            BrowserDispatcher.gotoBrowserByB2C(this, InviteUrl)
        }

    }

    override fun onResume() {
        super.onResume()
        walletPresenter.initWalletData()
    }

    override fun onDestroy() {
        super.onDestroy()
        walletPresenter.onDetach()
    }

    override fun fillData(sumAmount: String?) {
        sumLayout.sumAmountTextView.text = sumAmount
    }

    fun initTitleBar() {
        toolbar.setBackgroundResource(R.drawable.titlebar_red_bg)
        val titleOptions = TitleBarOptions.Builder()
        titleOptions
                .leftAction(object : DefaultLeftOptions(R.drawable.standard_back_red_selector) {
                    override fun onClick(view: View) {
                        onBackPressed()
                    }
                })
                .titleAction(DefaultTitleOptions(this, R.string.account_balance, R.color.white))
                .build()

        toolbar.build(titleOptions.build())
    }

}