package com.netease.nim.uikit.business.redpacket.activity

import android.content.Context
import android.content.Intent
import android.graphics.Color
import android.os.Build
import android.os.Bundle
import android.view.View
import android.webkit.WebSettings
import com.netease.nim.uikit.R
import com.netease.nim.uikit.common.activity.UI
import com.netease.nim.uikit.common.activity.titlebar.DefaultLeftOptions
import com.netease.nim.uikit.common.activity.titlebar.DefaultTitleOptions
import com.netease.nim.uikit.common.activity.titlebar.TitleBarOptions
import kotlinx.android.synthetic.main.activity_help.*

/**
 * 红包帮助
 * Created by lan on 2018/9/16.
 */
class RedPacketHelpActivity : UI() {

    companion object {
        fun start(context: Context) {
            context.startActivity(Intent(context, RedPacketHelpActivity::class.java))
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_help)

        initTitleBar()
        initWebView()
    }

    private fun initTitleBar() {
        findViewById<View>(R.id.toolbar).setBackgroundResource(R.drawable.titlebar_red_bg)
        val builder = TitleBarOptions.Builder()
                .leftAction(object : DefaultLeftOptions(R.drawable.standard_back_red_selector) {
                    override fun onClick(view: View) {
                        onBackPressed()
                    }
                })
                .titleAction(DefaultTitleOptions(this, R.string.red_packet_help, R.color.white))
        setTitleBar(R.id.toolbar, R.drawable.titlebar_red_shadow,builder.build())
    }

    private fun initWebView() {
        helpWebView.setBackgroundColor(Color.argb(0, 0, 0, 0))
        val settings = helpWebView.settings
        settings.saveFormData = false
        settings.useWideViewPort = false
        settings.setSupportZoom(true)
        settings.builtInZoomControls = false
        settings.domStorageEnabled = true
        settings.loadsImagesAutomatically = true
        settings.loadWithOverviewMode = true
        settings.useWideViewPort = true
        settings.setAppCacheEnabled(true)
        settings.allowFileAccess = true
        settings.cacheMode = WebSettings.LOAD_NO_CACHE
        if (Build.VERSION.SDK_INT < 19) {
            helpWebView.setBackgroundColor(Color.argb(1, 0, 0, 0))
        }
        helpWebView.loadUrl(getFile())
    }

    private fun getFile() : String {
        return "https://www.zidanduanxin.com/c2c-faq.html"
    }
}