package com.netease.nim.uikit.business.redpacket.activity

import android.content.Context
import android.content.Intent
import android.os.Bundle
import com.netease.nim.uikit.R
import com.netease.nim.uikit.business.redpacket.fragment.RedPacketInfoFragment
import com.netease.nim.uikit.business.session.constant.Extras
import com.netease.nim.uikit.common.activity.UI
import com.netease.nim.uikit.impl.database.RedPacketInfoV2

class RedPacketInfoActivity : UI() {

    companion object {

        fun starter(context: Context, redPacketInfoV2: RedPacketInfoV2, showDetailBtn: Boolean) {
            val intent = Intent(context, RedPacketInfoActivity::class.java)
            intent.putExtra(Extras.EXTRA_RED_PACKET, redPacketInfoV2)
            intent.putExtra(Extras.EXTRA_SHOW_BTN, showDetailBtn)
            context.startActivity(intent)
        }
    }

    private val redPacketInfo by lazy {
        intent.getSerializableExtra(Extras.EXTRA_RED_PACKET) as RedPacketInfoV2
    }

    private val showDetailBtn by lazy {
        intent.getBooleanExtra(Extras.EXTRA_SHOW_BTN, true)
    }

    private val redPacketInfoFrag by lazy {
        RedPacketInfoFragment.newInstance(redPacketInfo, showDetailBtn)
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_rp_info)
        supportFragmentManager.beginTransaction()
                .add(R.id.containerLayout, redPacketInfoFrag)
                .commitAllowingStateLoss()

    }

}