package com.netease.nim.uikit.business.redpacket.activity

import android.content.Context
import android.content.Intent
import android.os.Bundle
import com.netease.nim.uikit.R
import com.netease.nim.uikit.business.redpacket.fragment.RedPacketInfoB2CFragment
import com.netease.nim.uikit.common.activity.UI

class RedPacketInfoB2CActivity : UI() {

    companion object {
        private const val AMOUNT_KEY = "AMOUNT_KEY"
        private const val IS_INVITE_KEY = "IS_INVITE_KEY"
        fun starter(context: Context, amount: String, isInvite: Boolean) {
            val intent = Intent(context, RedPacketInfoB2CActivity::class.java).apply {
                putExtra(AMOUNT_KEY, amount)
                putExtra(IS_INVITE_KEY, isInvite)
            }
            context.startActivity(intent)
        }
    }

    private val redPacketInfoFrag by lazy {
        RedPacketInfoB2CFragment.newInstance(intent.getStringExtra(AMOUNT_KEY), false, intent.getBooleanExtra(IS_INVITE_KEY, false))
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_rp_info)

        supportFragmentManager.beginTransaction()
                .add(R.id.containerLayout, redPacketInfoFrag)
                .commitAllowingStateLoss()
    }

}