package com.netease.nim.uikit.business.redpacket.activity

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.view.View
import com.netease.nim.uikit.R
import com.netease.nim.uikit.api.NimUIKit
import com.netease.nim.uikit.business.redpacket.fragment.RedPacketInfoC2CFragment
import com.netease.nim.uikit.business.redpacket.presenter.RPInfoPresenter
import com.netease.nim.uikit.business.session.constant.Extras
import com.netease.nim.uikit.business.uinfo.UserInfoHelper
import com.netease.nim.uikit.common.activity.UI
import com.netease.nim.uikit.common.activity.titlebar.*
import com.netease.nim.uikit.impl.NimUIKitImpl
import com.netease.nim.uikit.impl.database.RedPacketInfo
import com.netease.nimlib.sdk.uinfo.model.NimUserInfo
import kotlinx.android.synthetic.main.activity_rp_info_c2c.*
import kotlinx.android.synthetic.main.item_red_packet_detail.*
import kotlinx.android.synthetic.main.red_packet_info_layout.*
import java.text.SimpleDateFormat
import java.util.*

class RedPacketInfoC2CActivity : UI() {

    companion object {

        fun starter(context: Context, redPacketInfo: RedPacketInfo, reGetInfo: Boolean = false, showDetailBtn: Boolean = true) {
            val intent = Intent(context, RedPacketInfoC2CActivity::class.java)
            intent.putExtra(Extras.EXTRA_RED_PACKET_INFO, redPacketInfo)
            intent.putExtra(Extras.EXTRA_REGET_RED_PACKET_INFO, reGetInfo)
            intent.putExtra(Extras.EXTRA_SHOW_BTN, showDetailBtn)
            context.startActivity(intent)
        }

    }

    private val redPacketInfoC2CFragment by lazy {
        RedPacketInfoC2CFragment().apply {
            arguments = intent.extras
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_rp_info_c2c)

        supportFragmentManager.beginTransaction()
                .add(R.id.containerLayout, redPacketInfoC2CFragment)
                .commitAllowingStateLoss()
    }

}