package com.netease.nim.uikit.business.redpacket.adapter

import android.content.Context
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.BaseAdapter
import android.widget.Button
import android.widget.ImageView
import android.widget.TextView
import com.netease.nim.uikit.R

/**
 * Created by lan on 2018/9/6.
 */
class InvitedListAdapter(val context: Context, val mData: List<Map<String, String>>) : BaseAdapter() {

    override fun getView(position: Int, convertView: View?, parent: ViewGroup?): View? {
        val result : View = convertView ?: LayoutInflater.from(context).inflate(R.layout.item_invited_list, parent, false)
        result.tag = convertView?.tag ?: WalletItemViewHolder(result)

        val viewHolder = result.tag as WalletItemViewHolder
        onBindViewHolder(viewHolder, position)
        return result
    }

    override fun getItem(position: Int): Any {
        return mData[position]
    }

    override fun getItemId(position: Int): Long {
        return position.toLong()
    }

    override fun getCount(): Int {
        return mData.size
    }

    private fun onBindViewHolder(holder: WalletItemViewHolder, position: Int) {
        val item = mData[position]
        holder.nameTv.text = item["name"]
        holder.inviteSourceTv.text = if (item["source"].equals("0")) "已发送短信邀请" else "已发送微信邀请"

        when {
            item["state"].equals("0") -> {
                holder.stateTv.visibility = View.VISIBLE
                holder.operateBtn.visibility = View.GONE
            }
            item["state"].equals("1") -> {
                holder.stateTv.visibility = View.GONE
                holder.operateBtn.visibility = View.VISIBLE
                holder.operateBtn.text = "砸破金蛋"
            }
            else -> {
                holder.stateTv.visibility = View.GONE
                holder.operateBtn.visibility = View.VISIBLE
                holder.operateBtn.text = "催他砸金蛋"
            }
        }
    }

    internal inner class WalletItemViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
        val avatarIv: ImageView = itemView.findViewById(R.id.avatar)
        val nameTv: TextView = itemView.findViewById(R.id.name)
        val inviteSourceTv: TextView = itemView.findViewById(R.id.invite_source)
        val stateTv: TextView = itemView.findViewById(R.id.state)
        val operateBtn: Button = itemView.findViewById(R.id.operate)
    }
}