package com.netease.nim.uikit.business.redpacket.adapter

import android.content.Context
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.BaseAdapter
import android.widget.ImageView
import android.widget.TextView
import com.netease.nim.uikit.R

/**
 * Created by lan on 2018/9/5.
 */
class WalletItemAdapter(val context: Context, val mData: List<Map<String, String>>) : BaseAdapter() {

    override fun getView(position: Int, convertView: View?, parent: ViewGroup?): View? {
        val result : View = convertView ?: LayoutInflater.from(context).inflate(R.layout.item_wallet_incom, parent, false)
        result.tag = convertView?.tag ?: WalletItemViewHolder(result)

        val viewHolder = result.tag as WalletItemViewHolder
        onBindViewHolder(viewHolder, position)
        return result
    }

    override fun getItem(position: Int): Any {
        return mData[position]
    }

    override fun getItemId(position: Int): Long {
        return position.toLong()
    }

    override fun getCount(): Int {
        return mData.size
    }

    private fun onBindViewHolder(holder: WalletItemViewHolder, position: Int) {
        val item = mData[position]
        holder.iconIv.setImageResource(if (item["type"].equals("gold")) R.drawable.wechat else R.drawable.weibo)
        holder.titleTv.text = item["title"]
        holder.timeTv.text = item["time"]
        holder.income.text = item["income"]
    }

    internal inner class WalletItemViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
        val iconIv: ImageView = itemView.findViewById(R.id.icon)
        val titleTv: TextView = itemView.findViewById(R.id.title)
        val timeTv: TextView = itemView.findViewById(R.id.time)
        val income: TextView = itemView.findViewById(R.id.income)
    }
}