package com.netease.nim.uikit.business.redpacket.fragment

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Button
import android.widget.TextView
import android.widget.Toast
import com.netease.nim.uikit.R
import com.netease.nim.uikit.business.favorite.view.PullUpToRefreshListView
import com.netease.nim.uikit.business.redpacket.adapter.WalletItemAdapter
import com.netease.nim.uikit.common.fragment.TFragment
import com.smartisan.libstyle.toast.NimToast
import java.util.*

/**
 * Created by lan on 2018/9/5.
 */
class PersonalWalletFragment : TFragment() {

    private var pageType : Int = 0

    private val mData : ArrayList<Map<String, String>> by lazy {
        ArrayList<Map<String, String>>()
    }

    private val mWalletItemAdapter : WalletItemAdapter by lazy {
        WalletItemAdapter(activity!!, mData)
    }

    companion object {
        fun newInstance(pageType: Int) : PersonalWalletFragment {
            val instance = PersonalWalletFragment()
            val bundle = Bundle()
            bundle.putInt("pageType", pageType)
            instance.arguments = bundle
            return instance
        }
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        val view = inflater.inflate(R.layout.fragment_personal_wallet, container, false)
        pageType = arguments?.getInt("pageType") ?: 0
        initView(view, pageType)
        return view
    }

    override fun onResume() {
        super.onResume()
        loadData()
    }

    private fun initView(view: View, type: Int) {
        val title = view.findViewById<TextView>(R.id.title)
        val withdrawBtn = view.findViewById<Button>(R.id.withdraw_btn)

        title.setText(if (type == 0) R.string.gold_income else R.string.silver_income)
        withdrawBtn.setOnClickListener {
            NimToast.makeToast(activity!!, "金币已提现至支付宝账户，清查收", Toast.LENGTH_SHORT).show()
        }

        val mItemList = view.findViewById<PullUpToRefreshListView>(R.id.item_list)
        mItemList.setEnabledPullDownToRefresh(false)
        mItemList.setAdapter(mWalletItemAdapter)
    }

    private fun loadData() {
        var data = ArrayList<Map<String, String>>()
        if (pageType == 0) {
            val item1 = HashMap<String, String>()
            item1.put("type", "gold")
            item1.put("title", "金蛋礼金")
            item1.put("time", "2018-09-05")
            item1.put("income", "12.22")
            data.add(item1)

            val item2 = HashMap<String, String>()
            item2.put("type", "gold")
            item2.put("title", "金蛋礼金")
            item2.put("time", "2018-09-05")
            item2.put("income", "12.22")
            data.add(item2)
        } else {
            val item1 = HashMap<String, String>()
            item1.put("type", "silver")
            item1.put("title", "与手机联系人成为好友")
            item1.put("time", "2018-09-05")
            item1.put("income", "20")
            data.add(item1)

            val item2 = HashMap<String, String>()
            item2.put("type", "silver")
            item2.put("title", "与手机联系人成为好友")
            item2.put("time", "2018-09-05")
            item2.put("income", "12.22")
            data.add(item2)
        }
        mData.clear()
        mData.addAll(data)
        mWalletItemAdapter.notifyDataSetChanged()
    }
}