package com.netease.nim.uikit.business.redpacket.request

import com.bullet.point.grpc.*
import io.reactivex.Observable
import smartisan.cloud.im.grpc.ProtoBuffManager
import smartisan.cloud.im.rxjava.RxGrpcRequestSender

class WalletReqSender : RxGrpcRequestSender<PointGrpc.PointBlockingStub>() {

    fun getWalletBalance(): Observable<GetWalletBalanceResponse> {
        return newRequest { stub ->
            stub.getWalletBalance(GetWalletBalanceRequest.newBuilder().setVerbose(3).build())
        }
    }

    fun getWithdrawList(): Observable<GetWithdrawListResponse>{
        return newRequest { stub ->
            stub.getWithdrawList(GetWithdrawListRequest.newBuilder().build())
        }
    }

    fun withdraw(amount: String): Observable<WithdrawResponse>{
        return newRequest { stub->
            stub.withdraw(WithdrawRequest.newBuilder().setAmount(amount).build())
        }
    }

    override fun getStub(): Observable<PointGrpc.PointBlockingStub> {
        return Observable.fromCallable { ProtoBuffManager.getInstance().doUserWalletStub() }
    }
}