package com.netease.nim.uikit.business.redpacket.viewholder

import android.view.View
import com.bumptech.glide.Glide
import com.netease.nim.uikit.R
import com.netease.nim.uikit.business.session.extension.MasterPressAttachment
import com.netease.nim.uikit.impl.NimUIKitImpl
import com.netease.nimlib.sdk.msg.model.IMMessage
import kotlinx.android.synthetic.main.nim_message_item_master_press.view.*

class MasterPressViewHolderWrapper(private val message: IMMessage,
                                   private val rootView: View) {
    fun getContentResId(): Int = R.layout.nim_message_item_master_press

    fun bindContentView() {
        if (message.attachment is MasterPressAttachment) {
            val attachment = message.attachment as MasterPressAttachment

            rootView.titleTextView.text = attachment.title
            rootView.contentTextView.text = attachment.content
            rootView.linkTextView.text = attachment.url

            Glide.with(rootView.context)
                    .load(attachment.coverUrl)
                    .into(rootView.iconImageView)
         }
    }

    fun getRightBg(): Int = NimUIKitImpl.getOptions().cardMessageRightBackground

}