package com.netease.nim.uikit.business.redpacket.viewholder

import android.view.View
import com.netease.nim.uikit.R
import com.netease.nim.uikit.business.recent.holder.MessageViewHolderBase
import com.netease.nim.uikit.common.ui.recyclerview.adapter.BaseQuickAdapter
import com.netease.nim.uikit.common.ui.recyclerview.holder.BaseViewHolder
import com.netease.nim.uikit.impl.NimUIKitImpl
import com.netease.nimlib.sdk.msg.model.IMMessage

class MessageViewHolderRedPacket(adapter: BaseQuickAdapter<*, *>?) : MessageViewHolderBase(adapter) {

    private var redPacketViewHolderWrapper: RedPacketViewHolderWrapper? = null

    override fun convert(holder: BaseViewHolder?, msg: IMMessage?, position: Int) {
        if (msg != null && holder != null) {
            redPacketViewHolderWrapper = RedPacketViewHolderWrapper(msg, holder.getConvertView())
        }
        super.convert(holder, msg, position)
    }

    override fun getContentResId(): Int {
        return redPacketViewHolderWrapper?.getContentResId() ?: R.layout.nim_message_item_red_packet
    }

    override fun inflateContentView(holder: BaseViewHolder?) {
    }

    override fun updateTimeParam() {
        tvTime.visibility = View.GONE
    }

    override fun bindContentView() {
//        mContentLayout.setBackgroundResource(getBackground())

        findViewById<View>(R.id.red_packet_container_layout).setBackgroundResource(getBackground())
        redPacketViewHolderWrapper?.bindContentView()
    }

    fun getBackground(): Int {
        return if (redPacketViewHolderWrapper?.isGetDone() == true) {
            NimUIKitImpl.getOptions().b2cRedPacketNoBlankBackground
        } else {
            NimUIKitImpl.getOptions().b2cRedPacketNoBlankBackground
        }
    }

}