package com.netease.nim.uikit.business.redpacket.viewholder

import android.view.View
import android.widget.FrameLayout
import android.widget.LinearLayout
import android.widget.TextView
import com.netease.nim.uikit.R
import com.netease.nim.uikit.business.session.extension.B2CRedPacketOpenedAttachment
import com.netease.nim.uikit.business.session.extension.RedPacketAttachment
import com.netease.nim.uikit.business.session.viewholder.MsgViewHolderBase
import com.netease.nim.uikit.common.ui.recyclerview.adapter.BaseMultiItemFetchLoadAdapter

/**
 * Created by lan on 2018/9/9.
 */
class MsgViewHolderOpenB2CRedPacket(adapter: BaseMultiItemFetchLoadAdapter<*, *>?) : MsgViewHolderBase(adapter) {

    var textView: TextView? = null

    override fun getContentResId(): Int = R.layout.nim_message_item_red_packet_open_tip

    override fun inflateContentView() {
        textView = findViewById(R.id.message_item_notification_label)
    }

    override fun bindContentView() {
        val attachment : B2CRedPacketOpenedAttachment = message.attachment as B2CRedPacketOpenedAttachment

        val textResId = when(attachment.redPacketType){
            RedPacketAttachment.RedPacketType.B2CInvitee -> R.string.invitee_red_packet
            RedPacketAttachment.RedPacketType.B2CInviter -> R.string.inviter_red_packet
            else -> R.string.invite_red_packet
        }
        textView?.setText(textResId)

        // 保留宽度用于占位
        avatarLeftContainer.layoutParams.height = 1
        avatarRightContainer.layoutParams.height = 1
        avatarLeftContainer.visibility = View.INVISIBLE
        avatarRightContainer.visibility = View.INVISIBLE
        progressBar.visibility = View.GONE


        // 为了和 MsgViewHolderTip 样式一样
        // 所以要设置父容器的 margin，MsgViewHolderTip
        // 在 MsgViewHolderBase 中也做了同样的特殊处理
        (contentContainer.layoutParams as LinearLayout.LayoutParams).setMargins(0, 0, 0, 0)
        (msgRootLayout.layoutParams as FrameLayout.LayoutParams).setMargins(0, 0, 0, 0)
    }

    override fun setStatus() {
        // 不做状态处理
    }

    override fun isMiddleItem(): Boolean {
        return true
    }

    override fun isShowHeadImage(): Boolean {
        return false
    }
}