package com.netease.nim.uikit.business.redpacket.viewholder

import android.view.LayoutInflater
import android.view.View
import com.netease.nim.uikit.R
import com.netease.nim.uikit.api.NimUIKit
import com.netease.nim.uikit.business.contact.core.item.ContactItem
import com.netease.nim.uikit.business.contact.core.model.ContactDataAdapter
import com.netease.nim.uikit.business.contact.core.viewholder.AbsContactViewHolder
import kotlinx.android.synthetic.main.select_contact_view_holder.view.*

class SelectContactHolder : AbsContactViewHolder<ContactItem>() {

    override fun refresh(adapter: ContactDataAdapter?, position: Int, item: ContactItem?) {
        item?:return
        val contact = item.contact
        view.apply {
            phoneNumberView.text = NimUIKit.getContactProvider().getPhoneNumberFrom(contact.phoneNumber)
            contactNameView.text = contact.displayName

            selectView.setOnClickListener {
                item.isChecked = !it.isSelected
                it.isSelected = item.isChecked
                adapter?.onClickCallback(item)
            }

            selectView.isSelected = item.isChecked
        }
    }

    override fun inflate(inflater: LayoutInflater): View {
        return inflater.inflate(R.layout.select_contact_view_holder, null)
    }
}