package com.netease.nim.uikit.business.session.actions

import android.app.Activity
import android.content.Intent
import android.view.View
import com.netease.nim.uikit.R
import com.netease.nim.uikit.api.NimUIKit
import com.netease.nim.uikit.business.redpacket.activity.SendRedPacketActivity
import com.netease.nim.uikit.business.redpacket.presenter.SendRedPacketPresenter
import com.netease.nimlib.sdk.msg.constant.SessionTypeEnum
import com.netease.nimlib.sdk.msg.model.IMMessage
import com.netease.nimlib.sdk.team.model.Team
import com.bullet.libcommonutil.log.sdk.wrapper.NimLog
import com.bullet.messenger.preferences.GlobalPreferences
import com.netease.nim.uikit.business.session.constant.Extras
import com.netease.nim.uikit.business.session.extension.MasterPressAttachment
import com.netease.nimlib.sdk.msg.MessageBuilder
import smartisan.cloud.im.util.Huginn
import smartisan.cloud.im.util.Muninn
import com.netease.nimlib.sdk.msg.MsgService
import com.netease.nimlib.sdk.NIMClient



class RedAction : BaseAction(R.drawable.dialogue_details_hongbao_icon, R.string.red_packet_text) {

    companion object {
        private const val REQUEST_CODE = 0
        private val TAG = RedAction::class.java.simpleName
    }


    override fun onClick(v: View?) {
//        AliPayAuthDialogActivity.startActivity(null, getContainer().activity)
//        RPInfoActivity.starter(getContainer().activity)
        val sessionType = getContainer().sessionType
        val sessionId = getContainer().account

        val intent = getContainer().activity.intent
        intent.putExtra(Extras.EXTRA_CLICK_SOURCE, ownerPanel.source)
        getContainer().activity.intent = intent
        SendRedPacketActivity.starter(getContainer().activity, sessionId, sessionType)

        if (sessionType == SessionTypeEnum.P2P) {
            Huginn.getInstance().onEvent(Muninn.PRIVATE_CHAR_RP)
        } else if (sessionType == SessionTypeEnum.Team) {
            Huginn.getInstance().onEvent(Muninn.GROUP_CHAT_RP)
        }

//        val msg = MessageBuilder.createCustomMessage(container.account, container.sessionType, MasterPressAttachment.create())
//        NIMClient.getService(MsgService::class.java).saveMessageToLocal(msg, true)
    }

    private fun getTeam(teamId: String, callback: (Team) -> Unit) {

        val t = NimUIKit.getTeamProvider().getTeamById(teamId)
        if (t != null) {
            callback.invoke(t)
        } else {
            NimUIKit.getTeamProvider().fetchTeamById(teamId) { success, result, code ->
                if (success && result != null) {
                    callback.invoke(result)
                } else {
                    NimLog.i(TAG, "get team failed!!code:$code")
                }
            }
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        if (resultCode == Activity.RESULT_OK
                && requestCode == REQUEST_CODE
                && data != null) {

            (data.getSerializableExtra(SendRedPacketPresenter.RED_PACKET_MSG_RESULT) as IMMessage?)?.let {
                getContainer().proxy.sendMessage(it)
                onActionExecuteSuccess()
            }
        }
    }

    override fun getIconResId(): Int {

        return if (sessionType == SessionTypeEnum.P2P) {
            if (GlobalPreferences.isRedPacketFirstEnable()) {
                R.drawable.dialogue_details_hongbao_icon
            } else {
                R.drawable.dialogue_details_redpacket_icon
            }
        } else if (sessionType == SessionTypeEnum.Team) {
            if (GlobalPreferences.isC2GRedPacketFirstEnable()) {
                R.drawable.dialogue_details_hongbao_icon
            } else {
                R.drawable.dialogue_details_redpacket_icon
            }
        } else {
            R.drawable.dialogue_details_redpacket_icon
        }

    }

}