package com.netease.nim.uikit.common.activity.titlebar

import android.view.View
import com.netease.nim.uikit.R
import com.netease.nim.uikit.common.util.preferences.PreferencesUtils

class ReplySwitchOption(private val replyTypeChangeCallback: (Boolean) -> Unit) : TitleBarOptions.TextViewOption(getBgRes(PreferencesUtils.getVoiceQuickReplay()), "", 0) {


    companion object {
        fun getBgRes(isVoiceReply: Boolean): Int {
            return if (isVoiceReply) {
                R.drawable.titlebar_switch_mic_icon_selector
            } else {
                R.drawable.titlebar_switch_textinput_icon_selector
            }
        }
    }

    override fun onClick(view: View?) {
        val voiceQuickReply = !PreferencesUtils.getVoiceQuickReplay()
        PreferencesUtils.saveVoiceQuickReplay(voiceQuickReply)
        view?.setBackgroundResource(getBgRes(voiceQuickReply))
        replyTypeChangeCallback.invoke(voiceQuickReply)
    }


}