package com.netease.nim.uikit.common.keyboard

import android.view.KeyEvent
import android.widget.EditText

/**
 * @author hedongjin <a href="mailto:hedongjin@smartisan.com">Contact me.</a>
 * @version 1.0
 * @since 18-7-13
 */
object HardKeyboardUtils {
    fun addCommonProcess(editText: EditText, enter: () -> Boolean) {
        val keyboardContext = KeyboardContext(3)
        keyboardContext.addKeyboardProcess(arrayOf(KeyEvent.KEYCODE_ENTER), object : KeyboardContext.IKeyboardProcess {
            override fun process(): Boolean = enter.invoke()
        })
        keyboardContext.addKeyboardProcess(arrayOf(KeyEvent.KEYCODE_SHIFT_LEFT, KeyEvent.KEYCODE_ENTER), object : KeyboardContext.IKeyboardProcess {
            override fun process(): Boolean {
                insert(editText, "\n")
                return true
            }
        })
        keyboardContext.addKeyboardProcess(arrayOf(KeyEvent.KEYCODE_SHIFT_RIGHT, KeyEvent.KEYCODE_ENTER), object : KeyboardContext.IKeyboardProcess {
            override fun process(): Boolean {
                insert(editText, "\n")
                return true
            }
        })
        editText.setOnKeyListener(keyboardContext)
    }

    private fun insert(editText: EditText, text: CharSequence) {
        editText.text.insert(editText.selectionEnd, text)
    }
}