package com.netease.nim.uikit.common.media

import android.app.Activity
import android.view.LayoutInflater
import android.widget.ImageView
import com.bullet.messenger.business.base.DataAnalytics
import com.bullet.messenger.business.base.DataTrackEvents
import com.netease.nim.uikit.R
import com.bullet.messenger.preferences.UserPreferences
import com.netease.nim.uikit.business.websearch.BrowserDispatcher
import com.netease.nim.uikit.common.ui.debug.UIDebug
import com.smartisan.libstyle.dialog.BulletAlertCustomViewDialog
import org.json.JSONObject
import smartisan.cloud.im.util.Huginn
import smartisan.cloud.im.util.Muninn

object VideoGuideController {


    fun checkAndShow(activity: Activity?, checkConfig: Boolean) {

        if (!UIDebug.SHOW_WHAT_IS_ZIDAN) {
            activity ?: return
            if (checkConfig) {

                if (!UserPreferences.canShowGuideVideo()) {
                    return
                }

                UserPreferences.disableGuideVideo()
            }
        }
        var json  = JSONObject().put(DataTrackEvents.AT_PAGE, "列表页")
        DataAnalytics.getInstance().track(DataTrackEvents.INTROVIDEO_POPUP, json)
        val dialog = BulletAlertCustomViewDialog.Builder(activity);
        dialog.setTitle(R.string.what_bullet_message_is);

//        val dialog = Dialog(activity)
//        dialog.requestWindowFeature(Window.FEATURE_NO_TITLE)
        val contentView = LayoutInflater.from(activity).inflate(R.layout.dialog_video_alert_layout, null, false)
        dialog.setCustomView(contentView)
        dialog.hideNegativeButton(true);
        dialog.hidePositiveButton(true);
//        dialog.window.setBackgroundDrawable(activity.resources.getDrawable(android.R.color.transparent))
//        dialog.window.setLayout(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT)
//        dialog.window.setGravity(Gravity.CENTER)

        val viewDialog = dialog.create();

        contentView.findViewById<ImageView>(R.id.video_cover_image).apply {
            setOnClickListener {
                var json = JSONObject().put(DataTrackEvents.POPUP_AT_PAGE,"列表页")
                DataAnalytics.getInstance().track(DataTrackEvents.START_PALY_INTROVIDEO, json)
                Huginn.getInstance().onEvent(Muninn.JC_TC)
                BrowserDispatcher.gotoBrowser(activity, "https://www.zidanduanxin.com/video/", null, true)
                viewDialog.dismiss()
            }
        }
        dialog.setOnCancelListener {
            var json = JSONObject().put(DataTrackEvents.POPUP_AT_PAGE,"列表页")
            DataAnalytics.getInstance().track(DataTrackEvents.CLOSE_VIDEOPOPUP, json)
        }
        viewDialog.show()

    }

    fun showGuideVideo(activity: Activity?) {
        activity ?: return
        Huginn.getInstance().onEvent(Muninn.JC_GRZY)
        BrowserDispatcher.gotoBrowser(activity, "https://www.zidanduanxin.com/video/", null, true)
    }
}