package com.netease.nim.uikit.common.presenter

import com.netease.nim.uikit.common.rx.DisposableCollector
import io.reactivex.disposables.Disposable

open class HandleDisposablePresenter : AbsPresenter() {

    private val disposableCollector = DisposableCollector()

    fun collectDisposable(collectorBlank: (() -> Disposable?)) {
        disposableCollector.collect(collectorBlank)
    }

    fun collectDisposable(disposable: Disposable?) {
        disposable?.let {
            disposableCollector.collect(disposable)
        }
    }

    override fun onDetach() {
        super.onDetach()
        clearDisposable()
    }

    fun clearDisposable(){
        disposableCollector.clearDisposable()
    }

}