package com.netease.nim.uikit.common.rx

import io.reactivex.disposables.Disposable

open class DisposableCollector {
    private val disposables = mutableListOf<Disposable?>()

    fun collect(collectorBlank: (() -> Disposable?)) {
        disposables.add(collectorBlank.invoke())
    }
    fun collect(disposable: Disposable?){
        disposables.add(disposable)
    }

    open fun clearDisposable() {
        disposables.forEach {
            it?.dispose()
        }
        disposables.clear()
    }

}